prompts = {
    "Creative Writing": "You are a creative writer tasked with crafting a captivating fictional book. The story should be set in a unique, imaginative world that blends elements of fantasy and reality. The protagonist is a young, adventurous character who discovers a hidden power within themselves that can alter the fate of their world. Develop a plot that weaves together themes of self-discovery, courage, and the battle between good and evil.\nBegin by describing the world in vivid detail—its landscapes, cultures, and the magical elements that make it unique. Introduce the protagonist's background, their personality traits, and the inciting incident that propels them into their journey. Along the way, create a cast of supporting characters—both allies and adversaries—that enrich the narrative and contribute to the protagonist's growth.\nInclude twists and turns that challenge the protagonist's beliefs and push them to their limits. The climax should be a moment of intense conflict where the protagonist must confront their greatest fear or enemy. Conclude with a resolution that reflects the protagonist's growth and the impact of their journey on their world.\nMake the narrative engaging with descriptive language, dynamic dialogue, and a compelling narrative voice that keeps readers invested from start to finish.",
    "Customer Support": "You are a customer support representative for an online retail company. A customer has reached out via email expressing frustration and disappointment because they received a damaged product. Your task is to craft a professional, empathetic, and effective response to the customer.\nBegin by acknowledging the customer's concerns and expressing genuine empathy for their experience. Apologize sincerely for the inconvenience caused by receiving a damaged item. Reassure the customer that their satisfaction is a priority for your company and that you are committed to resolving the issue promptly.\nDetail the steps you will take to address their complaint, such as arranging a replacement or processing a full refund, depending on the customer's preference. Offer to cover any additional shipping costs and provide clear instructions for returning the damaged product if necessary.\nAdditionally, consider providing a small gesture of goodwill, such as a discount on their next purchase or a complimentary item, to help restore their confidence in your company. Conclude by thanking the customer for bringing this issue to your attention and inviting them to reach out with any further questions or concerns.\nEnsure your response is concise, polite, and focused on resolving the issue to maintain a positive customer relationship and enhance their experience with your company.",
    "Technical Support": "You are a technical support specialist for an internet service provider (ISP). A customer has contacted you regarding a network issue they are facing, where their internet connection drops intermittently throughout the day. Your task is to create a comprehensive response that guides the customer through troubleshooting steps to identify and resolve the issue.\nBegin by expressing empathy for the inconvenience caused by the unstable network and assuring the customer that you are here to help. Request specific details about their setup, such as the type of modem/router they are using, whether they are connected via Wi-Fi or Ethernet, and if other devices in the home are also affected by the drops.\nSuggest initial troubleshooting steps, such as restarting the modem/router, checking for loose cables, and ensuring the firmware is up to date. Advise the customer to move closer to the router if using Wi-Fi or try switching to a different frequency band (2.4 GHz or 5 GHz).\nIf the issue persists, guide the customer to check for potential interference from other electronic devices or structural obstructions. Offer advanced diagnostics, such as running a network speed test or checking the ISP service status page for outages. Conclude by providing instructions on how to contact you for further assistance if the problem is not resolved.",
    "Marketing and Sales": "You are a marketing and sales specialist working for a tech company that is launching a new cloud computing product. Your task is to draft an engaging and persuasive email campaign to announce the product launch to potential customers and encourage them to learn more or make a purchase.\nBegin the email with a compelling subject line that grabs attention and clearly communicates the value of the new cloud computing product. Start the body of the email with a warm greeting and a brief introduction to the product, highlighting its key features and benefits, such as enhanced scalability, security, and cost-efficiency.\nExplain how the product addresses common pain points in cloud computing, such as managing large data sets, ensuring compliance, or optimizing resource allocation. Use persuasive language and customer-centric messaging to convey how the product can transform their business operations and drive growth.\nInclude a strong call to action, inviting recipients to sign up for a free trial, attend a live demo, or visit a landing page to learn more about the product. Offer an exclusive launch discount or limited-time offer to create urgency. Conclude the email by thanking the recipients for their time and encouraging them to reach out with any questions or to schedule a consultation.\nEnsure the email is visually appealing with a clean layout, compelling images, and easily scannable sections.",
    "Product Development": "You are a product manager tasked with writing a Product Requirements Document (PRD) for a new cloud computing tool. This tool is designed to help businesses manage and optimize their cloud resources more efficiently. Your PRD should provide a clear and comprehensive overview of the product's purpose, target audience, key features, and technical specifications.\nStart with an 'Overview' section that introduces the product and its strategic importance in the context of current market needs and trends. Include a 'Purpose and Scope' subsection that explains what the tool aims to achieve, such as improving cloud resource allocation, reducing costs, or enhancing data security. Define the 'Target Audience' by describing the types of businesses or professionals who will benefit most from this tool.\nIn the 'Features and Functionalities' section, list and describe the core features, such as automated cloud cost management, real-time monitoring, scalability options, and compliance tools. Each feature should have a brief description, priority level, and any relevant user stories. Include a 'Technical Requirements' section that outlines the technology stack, integration capabilities, and any dependencies or constraints.\nConclude with a 'Timeline and Milestones' section that provides an estimated schedule for development phases, testing, and launch. Add a 'Risks and Mitigations' section to identify potential challenges and how they will be addressed. Ensure the PRD is detailed yet concise, with clear, actionable information for stakeholders.",
    "Education and Training": "You are an educator tasked with developing a six-week course syllabus on Artificial Intelligence (AI) for college students. The course should provide a comprehensive introduction to AI, covering fundamental concepts, practical applications, and ethical considerations. Your syllabus should be designed to engage students with varying levels of prior knowledge in computer science and AI.\nBegin with a 'Course Overview' section that outlines the course objectives, learning outcomes, and the skills students will acquire by the end of the course. Include a brief description of each week's topic, highlighting the key areas of focus, such as AI history, machine learning algorithms, neural networks, natural language processing, and computer vision.\nFor each week, provide a detailed breakdown that includes lecture topics, reading assignments, and any required or recommended resources, such as textbooks, research papers, or online materials. Specify the format of the classes, whether they will be lectures, hands-on labs, or group discussions. Include details on assignments, projects, or quizzes that will help reinforce the material covered each week.\nIn the 'Assessment and Evaluation' section, outline how students' performance will be measured throughout the course, such as through quizzes, participation, a mid-term project, or a final exam. Conclude with a 'Course Schedule' that provides a clear timeline for each week's content and activities, ensuring a balanced mix of theory and practical application.",
    "Research and Analysis": "You are a researcher tasked with writing a comprehensive research proposal to investigate consumer behavior in online grocery shopping. The proposal should provide a clear framework for understanding the factors that influence consumer decisions and preferences when purchasing groceries online. Your proposal should be structured to outline the research objectives, methodology, expected outcomes, and potential implications.\nStart with an 'Introduction' section that provides background on the growth of online grocery shopping, citing relevant statistics or market trends. Define the 'Research Objectives,' specifying what you aim to uncover, such as identifying key factors that drive consumer preferences, understanding barriers to adoption, and analyzing demographic differences in shopping behavior.\nIn the 'Literature Review' section, summarize existing research on consumer behavior in e-commerce, particularly in the context of grocery shopping. Highlight gaps in the current knowledge that your study aims to fill. Follow with a 'Research Methodology' section that details your approach, including the research design, sample size, data collection methods (surveys, interviews, or observational studies), and data analysis techniques.\nDescribe the 'Expected Outcomes' of your research, such as insights into consumer preferences or strategies to enhance user experience on grocery platforms. Conclude with a 'Significance and Implications' section that discusses how the findings could benefit businesses, policymakers, or other stakeholders. Ensure the proposal is clear, well-structured, and compelling to potential funders or academic reviewers.",
    "Social Media Management": "You are a social media manager tasked with developing a detailed monthly content calendar for Instagram for a brand that focuses on health and wellness. The calendar should include a variety of post ideas, engaging captions, relevant hashtags, and strategies to boost engagement and follower interaction. Your content plan should align with the brand’s messaging, aesthetics, and overall marketing goals.\nBegin by outlining the 'Content Goals' for the month, such as increasing brand awareness, driving website traffic, or promoting a new product launch. Provide a 'Weekly Theme' for each week of the month, such as 'Mindful Mondays' or 'Fitness Fridays,' to create consistency and keep the audience engaged.\nFor each day of the week, specify a 'Post Idea,' including the type of content (photo, video, carousel, or story) and the topic (e.g., healthy recipes, workout tips, or motivational quotes). Write engaging 'Captions' that resonate with the audience, include 'Call-to-Actions' to encourage likes, comments, or shares, and suggest a set of 'Relevant Hashtags' to increase visibility.\nIncorporate 'Engagement Strategies' such as hosting a giveaway, conducting a poll, or encouraging user-generated content. Conclude with a 'Performance Review Plan' to analyze the success of each post and adjust future strategies based on audience engagement and feedback. Ensure the content calendar is well-organized, creative, and strategically designed to maximize engagement.",
    "Health and Wellness": "You are a wellness coach tasked with creating a comprehensive 30-day self-care challenge for your clients. The challenge should be designed to promote overall well-being, including physical health, mental clarity, emotional balance, and relaxation. Your goal is to provide daily activities that are easy to follow, engaging, and beneficial for clients of all fitness levels and wellness backgrounds.\nBegin by outlining the 'Challenge Overview,' including the purpose of the challenge and the benefits participants can expect, such as reduced stress, improved mood, increased energy, and better sleep. Create a 'Daily Activity Plan' with specific self-care activities for each day, such as mindfulness meditation, a gratitude journal entry, a 20-minute walk in nature, or a digital detox session.\nFor each activity, provide a brief 'Description' and any necessary 'Instructions' to help clients understand how to perform the activity effectively. Include 'Tips' for maximizing the benefits, such as focusing on breath during meditation or setting a positive intention for the day. Suggest 'Modifications' to accommodate different fitness levels or personal preferences.\nIncorporate 'Motivational Messages' and 'Encouragement' to keep clients engaged and committed to the challenge. Conclude with a 'Reflection and Feedback' section, encouraging participants to share their experiences, insights, and progress. Ensure the 30-day self-care challenge is well-structured, accessible, and supportive of a holistic approach to health and wellness.",
    "Legal and Compliance": "You are a legal advisor tasked with drafting a detailed policy document for a tech company on how to handle customer data in compliance with the General Data Protection Regulation (GDPR). The policy should outline the company's commitment to protecting customer privacy, detail the procedures for data collection, storage, processing, and deletion, and ensure adherence to GDPR requirements.\nBegin with an 'Introduction' section that states the company's dedication to data privacy and GDPR compliance. Provide an overview of GDPR's key principles, such as data minimization, purpose limitation, and transparency. Include a 'Scope' section that defines the types of data covered, including personal data, sensitive data, and any specific categories relevant to the company's operations.\nDetail the 'Data Collection and Processing' procedures, explaining how customer data will be collected (e.g., through websites, apps, or forms) and the lawful basis for processing such data. Include guidelines on obtaining explicit consent and maintaining records of consent.\nIn the 'Data Storage and Security' section, outline measures to protect customer data, such as encryption, access controls, and regular security audits. Include a 'Data Retention and Deletion' policy specifying how long data will be retained and the procedures for securely deleting it when no longer needed.\nConclude with a 'Rights of Data Subjects' section, explaining how customers can access, rectify, or request the deletion of their data. Include a 'Compliance and Monitoring' section to ensure ongoing adherence to GDPR requirements and outline the procedures for handling data breaches. Ensure the policy is clear, comprehensive, and accessible to all employees.",
    "Human Resources": "You are a Human Resources manager tasked with designing a comprehensive onboarding program for new employees at a mid-sized tech firm. The program should be structured to help new hires quickly acclimate to their roles, understand the company culture, and become productive team members. Outline a detailed week-by-week onboarding plan that includes orientation sessions, technical training, cultural integration activities, mentoring programs, and regular check-ins.\nStart with a 'Week 1: Orientation and Introduction' plan that covers welcome sessions, introductions to key team members, and a company overview, including its mission, vision, and values. Include an 'Administrative Setup' section where new hires complete necessary paperwork and receive equipment and system access.\nFor 'Weeks 2-3: Technical Training and Role-Specific Learning,' provide a schedule for training sessions on essential tools, software, and company processes. Outline role-specific training tailored to the new hire's position, with opportunities for hands-on practice and shadowing experienced colleagues.\nIn 'Weeks 4-5: Cultural Integration and Team Building,' include activities that promote cultural understanding and team cohesion, such as cross-departmental meet-and-greets, team-building exercises, and lunch-and-learn sessions.\nIntroduce a 'Mentoring Program' where each new hire is paired with a mentor for guidance and support. Conclude with 'Week 6: Regular Check-ins and Feedback,' where new hires have one-on-one meetings with their managers and HR to discuss progress, address concerns, and set goals for continued development. Ensure the onboarding program is engaging, supportive, and tailored to foster a positive employee experience.",
    "Finance and Accounting": "You are a finance expert tasked with creating a detailed investment guide for young professionals who are looking to start their investment journey. The guide should provide a comprehensive overview of different investment options, explain key financial concepts, and offer practical advice on building a diversified portfolio. Your goal is to make investing accessible and understandable for beginners while emphasizing long-term growth and risk management.\nBegin with an 'Introduction' that outlines the importance of investing early, the benefits of compound interest, and the impact of inflation on savings. Include a section on 'Investment Basics,' explaining fundamental concepts such as risk tolerance, time horizon, and the difference between stocks, bonds, mutual funds, ETFs, and other asset classes.\nProvide a 'Step-by-Step Investment Strategy' that guides young professionals through the process of setting financial goals, determining their risk appetite, and choosing the right investment vehicles. Include practical tips on how to research and select individual stocks, mutual funds, or ETFs, as well as advice on low-cost investing options like index funds and robo-advisors.\nIn the 'Portfolio Diversification and Risk Management' section, discuss the importance of diversifying investments across different asset classes and sectors to minimize risk. Conclude with a 'Long-Term Planning and Review' section, encouraging regular portfolio reviews and adjustments based on life changes or market conditions. Ensure the investment guide is clear, engaging, and tailored to help young professionals make informed financial decisions.",
    "Software Development": "You are a software developer tasked with writing a detailed guide on how to create unit test cases for FastAPI-based microservices. The guide should explain the importance of unit testing in software development, particularly for microservices, and provide step-by-step instructions on setting up and writing effective test cases. Include practical examples to illustrate key concepts and best practices.\nStart with an 'Introduction' section that explains what unit testing is and why it is crucial for ensuring the reliability and functionality of microservices built with FastAPI. Highlight the benefits of unit testing, such as catching bugs early, facilitating code refactoring, and improving code quality.\nProvide a 'Setup and Configuration' section that outlines the necessary tools and libraries, such as PyTest, HTTPX, and FastAPI’s built-in testing client. Include instructions on installing dependencies and configuring the testing environment.\nIn the 'Writing Unit Test Cases' section, explain how to write test cases for different parts of a FastAPI microservice, such as endpoint handlers, dependency injections, and middleware. Provide clear examples of test functions that use PyTest and HTTPX to send requests and validate responses. Discuss how to use fixtures for setup and teardown processes, mock external dependencies, and assert expected outcomes.\nConclude with a 'Best Practices' section that offers tips on organizing test files, writing meaningful test names, and ensuring comprehensive test coverage. Encourage regular testing throughout the development lifecycle to maintain high code quality. Ensure the guide is clear, practical, and tailored to help developers effectively test FastAPI microservices.",
    "Gaming and Entertainment": "You are a game designer tasked with creating a detailed concept document for a new fantasy adventure game. The document should outline the game's core elements, including its storyline, characters, world-building, gameplay mechanics, and visual style. Your goal is to present a compelling vision that captures the essence of the game and highlights its unique features to potential stakeholders.\nStart with an 'Introduction' section that provides an overview of the game's premise, setting, and target audience. Describe the game's 'Storyline' in detail, outlining the main plot, key conflicts, and overarching themes, such as heroism, exploration, or magic. Introduce the primary 'Characters,' including the protagonist, allies, and antagonists, with descriptions of their backstories, motivations, and unique abilities.\nIn the 'World-Building' section, detail the game's setting, including its geography, cultures, and lore. Describe key locations, such as mystical forests, ancient ruins, or bustling towns, and explain how the environment influences the gameplay experience.\nOutline the 'Gameplay Mechanics,' focusing on core features like combat systems, exploration, puzzle-solving, and character progression. Include a 'Visual Style and Art Direction' section that describes the game's artistic style, such as realistic, stylized, or hand-drawn, and provide examples of inspiration or references.\nConclude with a 'Unique Selling Points' section that highlights what sets the game apart from other fantasy adventure titles. Ensure the concept document is clear, engaging, and provides a comprehensive vision for the game's development.",
    "General Knowledge": "You are an educator tasked with creating an in-depth lesson plan on climate change for middle school students. The lesson plan should be engaging, informative, and age-appropriate, providing a comprehensive understanding of climate change, its causes, impacts, and solutions. Your goal is to educate students on the science behind climate change and encourage them to think critically about their role in combating it.\nStart with a 'Lesson Objectives' section that outlines the key learning goals, such as understanding the greenhouse effect, identifying human activities that contribute to climate change, and recognizing the environmental and social impacts of global warming. Include an 'Introduction' activity to engage students, such as a short video or a simple experiment demonstrating the greenhouse effect.\nIn the 'Main Content' section, provide detailed information on the causes of climate change, including the burning of fossil fuels, deforestation, and industrial activities. Discuss the impacts of climate change on weather patterns, sea levels, and biodiversity. Include interactive activities, such as group discussions, role-playing exercises, or a climate change trivia quiz, to reinforce learning.\nConclude with a 'Solutions and Actions' section that encourages students to think about how they can make a difference, such as reducing energy consumption, recycling, or advocating for environmental policies. Provide a 'Homework Assignment' that involves researching a climate-related topic or creating a poster on ways to combat climate change. Ensure the lesson plan is well-structured, engaging, and promotes active learning.",
}
